## com.lowagie.text.pdf
Class SimpleNamedDestination

    java.lang.Object
      com.lowagie.text.pdf.SimpleNamedDestination

All Implemented Interfaces:
  SimpleXMLDocHandler

    public class SimpleNamedDestination

extends java.lang.Object
implements SimpleXMLDocHandler

Author:
  Paulo Soares (psoares@consiste.pt)

Field Summary
`private java.util.HashMap` `xmlLast`
`private java.util.HashMap` `xmlNames`

Constructor Summary
`private` `SimpleNamedDestination()`

Method Summary
`(package private) static PdfArray` `createDestinationArray(java.lang.String value, PdfWriter writer)`
`void` `endDocument()` Called after the document is parsed.
`void` `endElement(java.lang.String tag)` Called when an end tag is found.
`static java.lang.String` `escapeBinaryString(java.lang.String s)`
`static void` `exportToXML(java.util.HashMap names, java.io.OutputStream out, java.lang.String encoding, boolean onlyASCII)` Exports the bookmarks to XML.
`static void` `exportToXML(java.util.HashMap names, java.io.Writer wrt, java.lang.String encoding, boolean onlyASCII)` Exports the bookmarks to XML.
`static java.util.HashMap` `getNamedDestination(PdfReader reader, boolean fromNames)`
`static java.util.HashMap` `importFromXML(java.io.InputStream in)` Import the names from XML.
`static java.util.HashMap` `importFromXML(java.io.Reader in)` Import the names from XML.
`static PdfDictionary` `outputNamedDestinationAsNames(java.util.HashMap names, PdfWriter writer)`
`static PdfDictionary` `outputNamedDestinationAsStrings(java.util.HashMap names, PdfWriter writer)`
`void` `startDocument()` Called when the document starts to be parsed.
`void` `startElement(java.lang.String tag, java.util.HashMap h)` Called when a start tag is found.
`void` `text(java.lang.String str)` Called when a text element is found.
`static java.lang.String` `unEscapeBinaryString(java.lang.String s)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### xmlNames

    private java.util.HashMap xmlNames

### xmlLast

    private java.util.HashMap xmlLast

Constructor Detail

### SimpleNamedDestination

    private SimpleNamedDestination()

Method Detail

### getNamedDestination

    public static java.util.HashMap getNamedDestination(PdfReader reader,
                                                        boolean fromNames)

### exportToXML

    public static void exportToXML(java.util.HashMap names,
                                   java.io.OutputStream out,
                                   java.lang.String encoding,
                                   boolean onlyASCII)
                            throws java.io.IOException

  Exports the bookmarks to XML. The DTD for this XML is:

       <?xml version='1.0' encoding='UTF-8'?>
       <!ELEMENT Name (#PCDATA)>
       <!ATTLIST Name
          Page CDATA #IMPLIED
       >
       <!ELEMENT Destination (Name)*>

  Parameters:
    `names` - the names
    `out` - the export destination. The stream is not closed
    `encoding` - the encoding according to IANA conventions
    `onlyASCII` - codes above 127 will always be escaped with &#nn; if `true`, whatever the encoding
  Throws:
    `java.io.IOException` - on error

### exportToXML

    public static void exportToXML(java.util.HashMap names,
                                   java.io.Writer wrt,
                                   java.lang.String encoding,
                                   boolean onlyASCII)
                            throws java.io.IOException

  Exports the bookmarks to XML.

  Parameters:
    `names` - the names
    `wrt` - the export destination. The writer is not closed
    `encoding` - the encoding according to IANA conventions
    `onlyASCII` - codes above 127 will always be escaped with &#nn; if `true`, whatever the encoding
  Throws:
    `java.io.IOException` - on error

### importFromXML

    public static java.util.HashMap importFromXML(java.io.InputStream in)
                                           throws java.io.IOException

  Import the names from XML.

  Parameters:
    `in` - the XML source. The stream is not closed
  Returns:
    the names
  Throws:
    `java.io.IOException` - on error

### importFromXML

    public static java.util.HashMap importFromXML(java.io.Reader in)
                                           throws java.io.IOException

  Import the names from XML.

  Parameters:
    `in` - the XML source. The reader is not closed
  Returns:
    the names
  Throws:
    `java.io.IOException` - on error

### createDestinationArray

    static PdfArray createDestinationArray(java.lang.String value,
                                           PdfWriter writer)
                                    throws java.io.IOException

  Throws:
    `java.io.IOException`

### outputNamedDestinationAsNames

    public static PdfDictionary outputNamedDestinationAsNames(java.util.HashMap names,
                                                              PdfWriter writer)
                                                       throws java.io.IOException

  Throws:
    `java.io.IOException`

### outputNamedDestinationAsStrings

    public static PdfDictionary outputNamedDestinationAsStrings(java.util.HashMap names,
                                                                PdfWriter writer)
                                                         throws java.io.IOException

  Throws:
    `java.io.IOException`

### escapeBinaryString

    public static java.lang.String escapeBinaryString(java.lang.String s)

### unEscapeBinaryString

    public static java.lang.String unEscapeBinaryString(java.lang.String s)

### endDocument

    public void endDocument()

  Description copied from interface: `SimpleXMLDocHandler`
  Called after the document is parsed.

  Specified by:
    `endDocument` in interface `SimpleXMLDocHandler`

### endElement

    public void endElement(java.lang.String tag)

  Description copied from interface: `SimpleXMLDocHandler`
  Called when an end tag is found.

  Specified by:
    `endElement` in interface `SimpleXMLDocHandler`
  Parameters:
    `tag` - the tag name

### startDocument

    public void startDocument()

  Description copied from interface: `SimpleXMLDocHandler`
  Called when the document starts to be parsed.

  Specified by:
    `startDocument` in interface `SimpleXMLDocHandler`

### startElement

    public void startElement(java.lang.String tag,
                             java.util.HashMap h)

  Description copied from interface: `SimpleXMLDocHandler`
  Called when a start tag is found.

  Specified by:
    `startElement` in interface `SimpleXMLDocHandler`
  Parameters:
    `tag` - the tag name
    `h` - the tag's attributes

### text

    public void text(java.lang.String str)

  Description copied from interface: `SimpleXMLDocHandler`
  Called when a text element is found.

  Specified by:
    `text` in interface `SimpleXMLDocHandler`
  Parameters:
    `str` - the text element, probably a fragment.